import os
import sys
from airflow import settings

import inspect


def create_alvin_dag():
    from alvin_airflow.lineage.metadata import dag_metadata_current
    print('Creating Alvin DAGs.....')
    dag_folder = settings.DAGS_FOLDER
    dag_source_code = inspect.getsource(sys.modules[dag_metadata_current.__name__])
    with open(os.path.join(dag_folder, 'alvin_metadata_dag.py'), 'w') as file:
        file.write(dag_source_code)


def create_alvin_dag_google_composer():
    print(f'Importing dag metadata dependencies.....')
    from alvin_airflow.lineage.metadata import dag_metadata_current
    from alving_airflow.config import GOOGLE_COMPOSER_BUCKET
    from gcloud import storage

    print(f'Creating Alvin DAGs on Google Composer path {GOOGLE_COMPOSER_BUCKET}.....')

    dag_source_code = inspect.getsource(sys.modules[dag_metadata_current.__name__])

    client = storage.Client()

    bucket = client.get_bucket(GOOGLE_COMPOSER_BUCKET)

    blob = bucket.blob('dags/alvin_metadata_dag.py')

    blob.upload_from_string(dag_source_code)
